/*
Copyright (C) 2001 StrmnNrmn

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/


#ifndef __TEXTURE_H__
#define __TEXTURE_H__

struct DrawInfo
{
	u32			Width;		// Describes the width of the locked area. Use lPitch to move between successive lines
	u32			Height;		// Describes the height of the locked area
	s32			Pitch;		// Specifies the number of bytes on each row (not necessarily bitdepth*width/8)
	void		*Surface;	// Pointer to the top left pixel of the image
};


// Virtual base class
class CTexture
{
	public:
		// Create textures with CTexture::Create()
		//CTexture();
		virtual ~CTexture() {}

		static CTexture * Create( u32 width, u32 height );

		virtual LPDIRECT3DTEXTURE8 GetTexture() = 0;
		virtual u32 GetPixelSize() const = 0;

#ifdef LIBPNG_SUPPORT
		virtual BOOL DumpImageAsPNG(LPCTSTR szFileName, u32 width, u32 height ) = 0;
#endif

		// Provides access to "surface"
		virtual BOOL StartUpdate(DrawInfo *di) = 0;
		virtual void EndUpdate(DrawInfo *di) = 0;

};


#endif	// __TEXTURE_H__
